/// @file
////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Copyright (C) 2018/19      Christian Lessig, Otto-von-Guericke Universitaet Magdeburg
///
////////////////////////////////////////////////////////////////////////////////////////////////////
///
///  module     : assignment 2
///
///  author     : lessig@isg.cs.ovgu.de
///
///  project    : GPU Programming
///
///  description: CUDA basics
///
////////////////////////////////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <limits>
#include <cassert>
#include <iomanip>

#include "cuda_util.h"

////////////////////////////////////////////////////////////////////////////////////////////////////
// Reduction for sum of array, global memory version
////////////////////////////////////////////////////////////////////////////////////////////////////
__global__
void
reduction1( int* data, const int size, const int stride) {

  // TODO: implement reduction

}

////////////////////////////////////////////////////////////////////////////////////////////////////
// Reduction for sum of array, shared memory version
////////////////////////////////////////////////////////////////////////////////////////////////////
__global__
void
reduction2( int* data, const int size) {

  // TODO: implement reduction

}

////////////////////////////////////////////////////////////////////////////////////////////////////
// Reduction for sum of array, version avoiding bank conflicts
////////////////////////////////////////////////////////////////////////////////////////////////////
__global__
void
reduction3( int* data, const int size) {

  // TODO: implement reduction

}

////////////////////////////////////////////////////////////////////////////////////////////////////
// Compute reference solution for reduction
// @return sum of array
////////////////////////////////////////////////////////////////////////////////////////////////////
int
reference( int* data, const int size) {

  // TODO: implement reference

  return 0;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//! Generate input for reduction
////////////////////////////////////////////////////////////////////////////////////////////////////
void
input( int*& data, const int size) {

  data = (int*) malloc( sizeof(int) * size);
  for( int i = 0; i < size; ++i) {
    data[i] = (float) i;
  }
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// initialize Cuda device
////////////////////////////////////////////////////////////////////////////////////////////////////
void
initDevice( int& device_handle, int& max_threads_per_block) {

  // TODO
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// initialize device memory
////////////////////////////////////////////////////////////////////////////////////////////////////
void
initDeviceMemory( int* data, int*& data_device, const int size) {

  // TODO
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//! Global memory version
////////////////////////////////////////////////////////////////////////////////////////////////////
void
version1( const int size) {

  int* data = nullptr;
  input( data, size);

  // TODO: compute reference solution

  // TODO: query available and set device

  // TODO: initialize device memory

  // TODO: determine thread layout

  // TODO: run kernel

  // TODO: copy result back to host and check correctness

  // TODO: clean up device memory

  // clean up host memory
  free( data);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//! Shared memory version
////////////////////////////////////////////////////////////////////////////////////////////////////
void
version2( const int size) {

  int* data = nullptr;
  input( data, size);

  // TODO: compute reference solution

  // TODO: query available and set device

  // TODO: initialize device memory

  // TODO: determine thread layout

  // TODO: run kernel

  // TODO: copy result back to host and check correctness

  // TODO: clean up device memory

  // clean up host memory
  free( data);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//! version avoiding divegent branching
////////////////////////////////////////////////////////////////////////////////////////////////////
void
version3( const int size) {

  int* data = nullptr;
  input( data, size);

  // TODO: compute reference solution

  // TODO: query available and set device

  // TODO: initialize device memory

  // TODO: determine thread layout

  // TODO: run kernel

  // TODO: copy result back to host and check correctness

  // TODO: clean up device memory

  // clean up host memory
  free( data);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// program entry point
////////////////////////////////////////////////////////////////////////////////////////////////////
int
main( int /*argc*/, char** /*argv*/ ) {

  const int n = 8192;

  version1( n);

  return EXIT_SUCCESS;
}
